---
title: RTCIceTransportState
slug: Web/API/RTCIceTransportState
tags:
  - API
  - Candidate
  - Enum
  - Enumerated Type
  - Enumeration
  - ICE
  - Media
  - RTCIceTransportState
  - Reference
  - Transport
  - Type
  - WebRTC
  - WebRTC API
  - state
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong><code>RTCIceTransportState</code></strong> enumerated type defines the string values which may be returned by the {{domxref("RTCiceTransport.state", "state")}} property on {{domxref("RTCIceTransport")}} objects. The transport state indicates which stage of the candidate gathering process is currently underway.</span></p>

<h2 id="Values">Values</h2>

<dl>
 <dt><code>"new"</code></dt>
 <dd>The {{domxref("RTCIceTransport")}} is currently gathering local candidates, or is waiting for the remote device to begin to transmit the remote candidates, or both. In this state, checking of candidates to look for those which might be acceptable has not yet begun.</dd>
 <dt><code>"checking"</code></dt>
 <dd>At least one remote candidate has been received, and the <code>RTCIceTransport</code> has begun examining pairings of remote and local candidates in order to attempt to identify viable pairs that could be used to establish a connection. Keep in mind that gathering of local candidates may still be underway, and, similarly, the remote device also may still be gathering candidates of its own.</dd>
 <dt><code>"connected"</code></dt>
 <dd>
 <p>A viable candidate pair has been found and selected, and the <code>RTCIceTransport</code> has connected the two peers together using that pair. However, there are still candidates pairings to consider, and there may still be gathering underway on one or both of the two devices.</p>

 <p>The transport may revert from the <code>"connected"</code> state to the <code>"checking"</code> state if either peer decides to cancel consent to use the selected candidate pair, and may revert to <code>"disconnected"</code> if there are no candidates left to check but one or both clients are still gathering candidates.</p>
 </dd>
 <dt><code>"completed"</code></dt>
 <dd>The transport has finished gathering local candidates and has received a notification from the remote peer that no more candidates will be sent. In addition, all candidate pairs have been considered and a pair has been selected for use. If consent checks fail on all successful candidate pairs, the transport state will change to <code>"failed"</code>.</dd>
 <dt><code>"disconnected"</code></dt>
 <dd>The ICE agent has determined that connectivity has been lost for this {{domxref("RTCIceTransport")}}. This is not a failure state (that's <code>"failed"</code>). A value of <code>"disconnected"</code> means that a transient issue has occurred that has broken the connection, but that should resolve itself automatically without your code having to take any action. See {{anch("The disconnected state")}} for additional details.</dd>
 <dt><code>"failed"</code></dt>
 <dd>The <code>RTCIceTransport</code> has finished the gathering process, has received the "no more candidates" notification from the remote peer, and has finished checking pairs of candidates, without successfully finding a pair that is both valid and for which consent can be obtained. <em>This is a terminal state, indicating that the connection cannot be achieved or maintained.</em></dd>
 <dt><code>"closed"</code></dt>
 <dd>The transport has shut down and is no longer responding to STUN requests.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>If an ICE restart occurs, the candidate gathering and connectivity check process is started over again; this will cause a transition from the <code>"connected"</code> state if the restart occurred while the state was <code>"completed"</code>. If the restart occurred during a transient <code>"disconnected"</code> state,  the state transitions to <code>"checking"</code></p>

<h3 id="The_disconnected_state">The disconnected state</h3>

<p><code>"disconnected"</code> is a transient state that occurs when the connection between the two peers fails in a manner that the WebRTC infrastructure can automatically correct once the connection is available again. It is <em>not</em> a failure state. Instead, you can think of <code>"disconnected"</code> as being similar to <code>"checking"</code> but with the added information that the connection had been working but at the moment is not.</p>

<p>Every {{Glossary("user agent")}} and platform may have its own scenarios that can trigger the <code>"disconnected"</code> state. Possible causes include:</p>

<ul>
 <li>The network interface being used by the connection has gone offline.</li>
 <li>{{Glossary("STUN")}} requests being sent to the remote device have gone unanswered repeatedly.</li>
</ul>

<p>The <code>"disconnected"</code> state can also occur when the transport has finished checking all existing candidate pairs and has not found a pair that will work—or a valid pair was found but rejected due to consent to use the pair being denied. In this scenario, the transport is still continuing to gather candidates, and/or to wait for candidates to be sent by the remote peer.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#rtcicerole', 'RTCIceRole')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceRole")}}</p>
</div>
